#include <stdio.h>


int get_int ( FILE *in ) {

	int c, count = 0;
	
	c = getc(in);
	
	while (c > '9' || c < '0')
		c = getc(in);
		
	while (c >= '0' && c <= '9') {
		count = count * 10 + (c - '0');
		c = getc(in);
		}
		
	return count;

	}
	
	
int calc_year ( FILE *in ) {

	int poss[20][200];
	int i, j, comps, bug;
	int y, a, b, trackers[20];
	int years[20][2];
	
	comps = get_int(in);
	
	if (comps == 0)
		return -2;
		
	for (i = 0; i < comps; i++) {
		y = get_int(in);
		a = get_int(in);
		b = get_int(in);
		years[i][0] = b-a;
		years[i][1] = y;
/*		if ((b-a)%100 == 0)
			bug = 100;
		else if ((b-a)%136 == 0)
			bug = 136;
		else
			bug = b - a;
		while (y < a)
			y += bug;
		poss[i][0] = y;
		for (j = 1; j < 200; j++) {
			poss[i][j] = poss[i][j - 1] + bug;
			}
*/		}

	while (1) {
		bug = 1;
		i = 0;
		while (bug && ++i < comps)
			bug = (years[i][1] == years[i-1][1]);
		if (bug)
			return years[0][1];
		a = 0;
		for (i = 1; i < comps; i++)
			if (years[i][1] < years[a][1])
				a = i;
		years[a][1] += years[a][0];
		if (years[a][1] > 10000)
			return -1;
		}
		
/*	for (i = 0; i < comps; i++)
		trackers[i] = 0;
		
	while (1) {
		bug = 1;
		i = 0;
		while (bug && ++i < comps)
			bug = (poss[i][trackers[i]] == poss[i - 1][trackers[i - 1]]);
		if (bug)
			break;
		for (i = 0; i < comps - 1; i++) {
			for (j = i + 1; j < comps; j++) {
				if (poss[i][trackers[i]] > poss[j][trackers[j]])
					if (poss[j][trackers[j]++] > 10000)
						return -1;
				if (poss[i][trackers[i]] < poss[j][trackers[j]])
					if (poss[i][trackers[i]++] > 10000)
						return -1;
				}
			}
		}
		
	return poss[0][trackers[0]];
*/	
	}
					
					
int main ( int argc , char *argv[] ) {
		
	FILE *in;
	int res, count = 1;
	
	in = fopen("y2k.in","r");
	
	while ((res = calc_year(in)) > -2) {
		if (res >= 0)
			printf("Case #%i:\nThe actual year is %i.\n\n",count++,res);
		else
			printf("Case #%i:\nUnknown bugs detected.\n\n",count++);
		}
	
	return 0;

	}
	
	
	
	
	
	
	
	
	
	
	
