#include <stdio.h>


int get_int ( FILE *in ) {

	int c, count = 0;
	
	c = getc(in);
	
	while (c > '9' || c < '0')
		c = getc(in);
		
	while (c >= '0' && c <= '9') {
		count = count * 10 + (c - '0');
		c = getc(in);
		}
		
	return count;

	}
	
	
int robber ( int n , FILE *in ) {

	char map [102][102][102];
	int width, height, steps;
	int i, j, k, l, nrinputs, x, y;
	int input[5], counter1, counter2;
	
	width = get_int(in);
	height = get_int(in);
	steps = get_int(in);
	
	if (!width && !height && !steps)
		return 0;
		
	for (i = 0; i <= steps + 1; i++)
		for (j = 0; j <= width + 1; j++)
			for (k = 0; k <= height + 1; k++)
				map[i][j][k] = 0;
				
	for (i = 1; i <= steps; i++)
		for (j = 1; j <= width; j++)
			for (k = 1; k <= height; k++)
				map[i][j][k] = 1;
				
	nrinputs = get_int(in);
	
	for (l = 0; l < nrinputs; l++) {
		input[0] = get_int(in);
		input[1] = get_int(in);
		input[2] = get_int(in);
		input[3] = get_int(in);
		input[4] = get_int(in);
		for (j = input[1]; j <= input[3]; j++)
			for (k = input[2]; k <= input[4]; k++)
				map[input[0]][j][k] = 0;
		for (i = input[0] + 1; i <= steps; i++) {
			for (j = 1; j <= width; j++)
				for (k = 1; k <= width; k++)
					if (!map[i-1][j][k] && !map[i-1][j][k + 1] && !map[i-1][j][k
					- 1] && !map[i-1][j + 1][k] && !map[i-1][j - 1][k])
						map[i][j][k] = 0;
			}
		for (i = input[0]-1; i >= 1; i--) {
			for (j = 1; j <= width; j++)
				for (k = 1; k <= width; k++)
					if (!map[i+1][j][k] && !map[i+1][j + 1][k] && !map[i+1][j -
					1][k] && !map[i+1][j][k+1] && !map[i+1][j][k-1])
						map[i][j][k] = 0;
			}
			
		}
		
	
/*	printf("lap %i...\n\n",l);
			
	for (i = 1; i <= steps; i++) {
		for (k = 1; k <= height; k++) {
			for (j = 1; j <= width; j++) {
				putchar(map[i][j][k] + '0');
				putchar(' ');
				}
			putchar('\n');
			}
		putchar('\n');
		}
*/		
	counter1 = 1;
	for (i = 1; counter1 && i <= steps; i++) {
		counter1 = 0;
		for (j = 1; !counter1 && j <= width; j++)
			for (k = 1; !counter1 && k <= height; k++)
				counter1 = map[i][j][k];
		}
		
	printf("Robbery #%i:\n",n);
		
	if (!counter1) {
		printf("The robber has escaped.\n\n");
		return 1;
		}
	
	counter1 = 0;
	for (i = 1; i <= steps; i++) {
		counter2 = 0;
		for (j = 1; j <= width; j++)
			for (k = 1; k <= height; k++)
				if (map[i][j][k]) {
					counter2++;
					x = j; y = k;
					}
		if (counter2 == 1) {
			counter1++;
			printf("Time step %i: The robber has been at %i,%i.\n",i,x,y);
			}
		}
		
	if (counter1 == 0)
		printf("Nothing known.\n");
		
	putchar('\n');
		
	return 1;
			
	}
					
					
int main ( int argc , char *argv[] ) {
		
	FILE *in;
	int counter = 1;
	
	in = fopen("robbery.in","r");
	
	while (robber(counter++,in));
	
	return 0;

	}
	
	
	
	
	
	
	
	
	
	
	
