#include <stdio.h>

#define powers2(a) (1 << (a))


int get_int ( FILE *in ) {

	int c, count = 0;
	
	c = getc(in);
	
	while (c > '9' || c < '0')
		c = getc(in);
		
	while (c >= '0' && c <= '9') {
		count = count * 10 + (c - '0');
		c = getc(in);
		}
		
	return count;

	}
	
	
int get_bin ( FILE *in ) {

	int c, count = 0;
	
	c = getc(in);
	
	while (c > '1' || c < '0')
		c = getc(in);
		
	while (c >= '0' && c <= '1') {
		count = count * 2 + (c - '0');
		c = getc(in);
		}
		
	return count;

	}
	
	
int calc ( int n , FILE *in ) {

	int vars[7], vals, nvars, nvals;
	int i, j, res = 0, pos;
	
	nvars = get_int(in);
	
	if (nvars == 0)
		return 0;
		
	for (i = 0; i < nvars; i++)
		vars[get_int(in) - 1] = i;
		
	res = get_bin(in);
	
	nvals = get_int(in);
	
	printf("S-Tree #%i:\n",n);
	
	for (i = 0; i < nvals; i++) {
		vals = get_bin(in);
		pos = 1;
		for (j = 0; j < nvars; j++)
			if (!(vals & powers2(vars[j])))
				pos += powers2(j);
		if ((res & powers2(pos-1)) > 0)
			putchar('1');
		else	
			putchar('0');
		}
		
	putchar('\n');
	putchar('\n');
	
	return 1;
	
	}
					
					
int main ( int argc , char *argv[] ) {
		
	FILE *in;
	int counter = 1;
	
	in = fopen("stree.in","r");
	
	while (calc(counter++,in));
	
	return 0;

	}
	
	
	
	
	
	
	
	
	
	
	
